package qubit.solutions.rumification;

import android.app.Notification;
import android.app.NotificationChannel;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.media.RingtoneManager;
import android.os.Handler;
import android.os.Looper;
import android.util.Log;

import androidx.annotation.NonNull;
import androidx.core.app.NotificationCompat;

import java.util.HashMap;
import java.util.Map;
import java.util.Timer;
import java.util.TimerTask;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;
import qubit.solutions.rumification.R;


import static android.R.drawable.ic_delete;

/**
 * RumificationPlugin
 */
public class RumificationPlugin implements FlutterPlugin, MethodCallHandler {
    /// The MethodChannel that will the communication between Flutter and native Android
    ///
    /// This local reference serves to register the plugin with the Flutter Engine and unregister it
    /// when the Flutter Engine is detached from the Activity
    private MethodChannel channel;
    private static int count = 0;
    public static final int NOTIFICATION_ID = 200;
    public static final String NOTIFICATION_REPLY = "NotificationReply";
    public static final String CHANNNEL_ID = "SimplifiedCodingChannel";
    public static final int REQUEST_CODE_APPROVE = 101;
    public static final String KEY_INTENT_APPROVE = "keyintenthelp";
    private Map<String, String> sharedData = new HashMap();
    public static final int REQUEST_CODE_SHARE = 102;
    private Context mContext;

    @Override
    public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
        channel = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), "rumification");
        channel.setMethodCallHandler(this);
        this.mContext = flutterPluginBinding.getApplicationContext();

        TimerTask task = new TimerTask() {
            @Override
            public void run() {
                count++;
                try {
                    new Handler(Looper.getMainLooper()).post(new Runnable() {
                        @Override
                        public void run() {


                            channel.invokeMethod("callback", "this callback from android works");

                        }
                    });

                } catch (Exception ex) {
                    Log.i("MethodChannel:", ex.toString());

                }


            }
        };
        Timer timer = new Timer();
        timer.scheduleAtFixedRate(task, 3000, 3000);

    }


    @Override
    public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {
        if (call.method.equals("getPlatformVersion")) {
            result.success("Android " + android.os.Build.VERSION.RELEASE);
        } else if (call.method.equals("CreateNotification")) {


            sendNotification("test", "test", mContext,call.arguments());
            result.success("Plugin was successful");
        } else {
            result.notImplemented();
        }
    }

    @Override
    public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
        channel.setMethodCallHandler(null);
    }

    private void sendNotification(String title, String body, Context context,Object map1) {

        Map<String, String> map = new HashMap<>();
        String title1 = map.get("title");
        String body1 = map.get("body");
        String icon1 = map.get("icon");
        String content1 = map.get("content");
        String time1 = map.get("time");

        try {
            //String title = convert(data,"title");
            //String body = convert(data,"body");
            String channel_id = "01";
            String channel_name = "basic_channel";
            int icoo = android.R.mipmap.sym_def_app_icon;
            int importance = NotificationManager.IMPORTANCE_HIGH;

            Bitmap icon = BitmapFactory.decodeResource(context.getResources(), android.R.mipmap.sym_def_app_icon);
            NotificationManager notificationManager = (NotificationManager) context.getSystemService(Context.NOTIFICATION_SERVICE);

            if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.O) {
                NotificationChannel mChannel = new NotificationChannel(
                        channel_id, channel_name, importance);

                notificationManager.createNotificationChannel(mChannel);
            }

            PendingIntent approvePendingIntent = PendingIntent.getBroadcast(
                    context,
                    REQUEST_CODE_APPROVE,
                    new Intent(context, NotificationReceiver.class)
                            .putExtra(KEY_INTENT_APPROVE, REQUEST_CODE_APPROVE),
                    PendingIntent.FLAG_UPDATE_CURRENT
            );

            PendingIntent sharePendingIntent = PendingIntent.getBroadcast(
                    context,
                    REQUEST_CODE_SHARE,
                    new Intent(context, NotificationReceiver.class)
                            .putExtra(KEY_INTENT_APPROVE, REQUEST_CODE_SHARE),
                    PendingIntent.FLAG_UPDATE_CURRENT
            );

            NotificationCompat.Builder notificationBuilder = new NotificationCompat.Builder(context, channel_id)
                    .setContentTitle(title)
                    .setContentText(body)
                    .setAutoCancel(true)
                    .setSound(RingtoneManager.getDefaultUri(RingtoneManager.TYPE_NOTIFICATION))
                    .setContentIntent(approvePendingIntent)
                    .setContentInfo(body)
                    .setLargeIcon(icon)
                    .setColor(Color.GRAY)
                    .setLights(Color.GRAY, 1000, 300)
                    .setDefaults(Notification.DEFAULT_VIBRATE)
                     .setSmallIcon(icoo)
                    .setPriority(Notification.PRIORITY_MAX)
                    //.setWhen(0)
                    .addAction(ic_delete, "ALTERNATE ROUTES", approvePendingIntent)
                    .addAction(ic_delete, "SEND THIS ALERT", sharePendingIntent);
            //.setContentIntent(approvePendingIntent);
            notificationManager.notify(NOTIFICATION_ID, notificationBuilder.build());

        } catch (Exception e) {
            Log.i("tag", e.getMessage());
        }
    }
}
